-- Execution-count profile.
-- Left margin shows the exact number of times that
-- the statement(s) on that line were executed.

       |without type_check -- makes no difference
       |
       |constant BATCH = 50
       |constant BENCH_TIME = 15
       |
       |constant SIZE = 500  -- finds primes up to SIZE*2+1
       |		     -- (only tests odd numbers)
       |constant ON = 1, OFF = 0
       |constant SCREEN = 1
       |
       |sequence flags 
       |
       |function sieve()
       |    integer prime, start, count, still_prime
       |
 11750 |    count = 0
 11750 |    flags = repeat(ON, SIZE)
 11750 |    for i = 1 to SIZE do
5875000 |	still_prime = flags[i]
5875000 |	if still_prime then
1962250 |	    prime = 2 * i 
1962250 |	    prime += 1 
1962250 |	    start = prime + i
1962250 |	    for k = start to SIZE by prime do
8272000 |		flags[k] = OFF
8272000 |	    end for 
1962250 |	    count += 1
       |	end if
5875000 |    end for
 11750 |    return count
       |end function
       |
       |atom t, cycles
       |
     1 |puts(SCREEN, "prime sieve benchmark ...\n")
     1 |cycles = 0
     1 |t = time()
     1 |while time() < t + BENCH_TIME do
   235 |    for iter = 1 to BATCH do
 11750 |	if sieve() != 167 then
       |	    puts(SCREEN, "whoops!\n")
       |	end if
 11750 |    end for
   235 |    cycles = cycles + BATCH
   235 |end while
     1 |t = time() - t
     1 |printf(SCREEN, "%6.1f sieves per second\n", cycles / t)
       |
       |-- display results
     1 |puts(SCREEN, "   2") -- 2 is also a prime
     1 |for i = 1 to SIZE do
   500 |    if flags[i] then
   167 |	printf(SCREEN, " %3d", i*2+1)
       |    end if
   500 |end for
       |

